/************************************/
/* wi̒nOtBbNύX */
/* (MAINGATE.DATp)                 */
/************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		i,j,k,m,c;
	int		dt[12],dtsw[12];
	int		sft;
	int		dttmp[4][8];
	int		dto[4][4],dtout;
	int		dt_b;
	int		startadd,endadd;


	if (argc != 5) {
		fprintf(stderr, "Usage: conv_gate startadd endadd inputfile outputfile\n");
		exit(1);
	}

/* open files */

	sscanf(argv[1],"%x",&startadd);
	sscanf(argv[2],"%x",&endadd);

	if ((infp = fopen(argv[3], "rb")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	if ((outfp = fopen(argv[4], "wb")) == NULL) {
		perror(argv[4]);
		exit(1);
	}

	for (i = 0;i < startadd;i ++) {
		if ( (c = fgetc(infp)) == EOF) {
			break;
		}
		fputc(c,outfp);
	}

	j = 0;
	for (;i < endadd;i ++) {
		if ( (c = fgetc(infp)) == EOF) {
			break;
		}
		if (j == 11) {

/* 0000_[0][0] 0000_[0][1] [0][3]_[0][2] */
/* 0000_[1][0] 0000_[1][1] [1][3]_[1][2] */

/*         [0][0] [0][1]  [0][7] */
/*         [1][0] [1][1]  [1][7] */

			fputc(0x0a, outfp);
			fputc(0x08, outfp);
			fputc(0x8a, outfp);
			fputc(0x0a, outfp);
			fputc(0x08, outfp);
			fputc(0x8a, outfp);

			fputc(0x08, outfp);
			fputc(0x0a, outfp);
			fputc(0xa8, outfp);
			fputc(0x08, outfp);
			fputc(0x0a, outfp);
			fputc(0xa8, outfp);

			j = 0;
		} else {
			j ++;
		}
	}

	while ( (c = fgetc(infp)) != EOF) {
		fputc(c,outfp);
	}

	fclose(infp);
	fclose(outfp);

	return(0);

}

