/*****************************************/
/* Thunder Bolt ̃OtBbNύX */
/* MG04.CHR                              */
/*****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		x,y,c1,c2;
	int		i,sft;
	int		dt;
	int		dto;
	int		data[72][56];


	if (argc != 3) {
		fprintf(stderr, "Usage: conv_mg04 inputfile outputfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	c1 = 0;
	c2 = 0;

	for (y = 0;y < 72;y ++) {
		for (x = 0;x < 56;x ++) {
			c2 = c1;
			c1 = fgetc(infp);
			if (c1 == EOF) {
				printf("File illigal\n");
				exit(1);
			}
			if ( (x < 28) && ( (x%2) == 1) ) {
				dto = 0x00;
				dto = dto | ( ((c2 & 0x80) == 0x00) ? 0x00 : 0x80);
				dto = dto | ( ((c2 & 0x20) == 0x00) ? 0x00 : 0x40);
				dto = dto | ( ((c2 & 0x08) == 0x00) ? 0x00 : 0x20);
				dto = dto | ( ((c2 & 0x02) == 0x00) ? 0x00 : 0x10);
				dto = dto | ( ((c1 & 0x80) == 0x00) ? 0x00 : 0x08);
				dto = dto | ( ((c1 & 0x20) == 0x00) ? 0x00 : 0x04);
				dto = dto | ( ((c1 & 0x08) == 0x00) ? 0x00 : 0x02);
				dto = dto | ( ((c1 & 0x02) == 0x00) ? 0x00 : 0x01);
				data[y][x/2] = dto;
			}
		}
	}

	dt = 0;
	dto = 0;
	for (y = 71;y >= 0;y --) {
		for (x = 0;x < 14;x ++) {
			sft = 0x80;
			c1 = data[y][x];
			for (i = 0;i < 8;i ++) {
				c2 = (c1 & sft);

				if (dt == 0) {

					if (c2 == 0) {
						dto ++;
						if (dto >= 0x100) {
							printf("Data overflow\n");
							exit(1);
						}
					} else {
						fputc(dto,outfp);
						dto = 1;
						dt = 1;
					}

				} else {

					if (c2 != 0) {
						dto ++;
						if (dto >= 0x100) {
							printf("Data overflow\n");
							exit(1);
						}
					} else {
						fputc(dto,outfp);
						dto = 1;
						dt = 0;
					}

				}

				sft = sft / 2;
			}
		}
	}

	fputc(dto,outfp);

	fclose(infp);
	fclose(outfp);

	return(0);

}

