/**************************************/
/* Sv[̃OtBbNύX */
/**************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		i,j,k,m,c;
	int		dt[16];
	int		dto,sft;
	int		startadd,endadd;


	if (argc != 5) {
		fprintf(stderr, "Usage: conv_p4 startadd endadd inputfile outputfile\n");
		exit(1);
	}

/* open files */

	sscanf(argv[1],"%x",&startadd);
	sscanf(argv[2],"%x",&endadd);


	if ((infp = fopen(argv[3], "rb")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	if ((outfp = fopen(argv[4], "wb")) == NULL) {
		perror(argv[4]);
		exit(1);
	}

	for (i = 0;i < startadd;i ++) {
		if ( (c = fgetc(infp)) == EOF) {
			break;
		}
		fputc(c,outfp);
	}

	j = 0;
	for (;i < endadd;i ++) {
		if ( (c = fgetc(infp)) == EOF) {
			break;
		}
		dt[j] = c;
		if (j == 15) {

/* dt[ 0: 3]:Lrbg */
/* dt[ 4: 7]: */
/* dt[ 8:11]: */
/* dt[12:15]: */

			for (k = 0;k < 4;k ++) {
				sft = 0x80;
				for (m = 0;m < 4;m ++) {
					dto = 0x10;
					if ( (dt[0*4+k] & sft) == 0) {
						dto |= 0x01;
					}
					if ( (dt[3*4+k] & sft) != 0) {
						dto |= 0x08;
					}
					if ( (dt[2*4+k] & sft) != 0) {
						dto |= 0x04;
					}
					if ( (dt[1*4+k] & sft) != 0) {
						dto |= 0x02;
					}
					fputc(dto,outfp);
					sft = sft >> 2;
				}
			}

			j = 0;
		} else {
			j ++;
		}
	}

	while ( (c = fgetc(infp)) != EOF) {
		fputc(c,outfp);
	}

	fclose(infp);
	fclose(outfp);

	return(0);

}

